public class VolatileExample {

    static int number = 0;
    // static volatile int number = 0;

    public static void main(String[] args) {
        ChangeMaker t1 = new ChangeMaker();
        ChangeListener t2 = new ChangeListener();

        t1.start();
        t2.start();
    }

    static class ChangeMaker extends Thread {
        @Override
        public void run() {
            for (int i = 0; i < 500000; i++) {
                number++;
                System.out.println("Changed number: " + number);
            }
        }
    }

    static class ChangeListener extends Thread {
        @Override
        public void run() {
            int localNumber = number;
            while(true) {
                if (localNumber != number){
                    localNumber = number;
                    System.out.println("Number changed!");
                }
            }
        }
    }
}